#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "get_preparation_data4xi.py">
#<abstract4xi abstract = "providing function get_preparation_data4xi"/>
#<refer4xi reference = "forking.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'get_preparation_data4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # winapi
    import _winapi
    from _winapi import WAIT_OBJECT_0, WAIT_TIMEOUT, INFINITE
except ImportError:
    if sys.platform == 'win32':
        raise
    _winapi = None
   

from pickle import _Pickler as Pickler
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
from multiprocessing import forking
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import constant_forking4xi
from constant_forking4xi import ConstantForking4Xi

import constant_process4xi
from current_process4xi import get_authkey_current_process4xi 

from examine4xi import examine4xi

import logger4xi

from original_dir4xi import get_original_dir4xi

from print4xi import print4xi

from time4xi import time4xi
#"
#/>

# ---------------------------------------------------------------------------------------------
#<function4xi function = "get-preparation-data4xi" usage = "
#      class Popen(object): <--- in this module 
#         def __init__(self, process_obj):
#                 prep_data = get_preparation_data(process_obj._name)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ---------------------------------------------------------------------------------------------
def get_preparation_data4xi(name): 
    '''
    Return info about parent needed by child to unpickle process object
    '''
    
    # -------------------------------------------------------------------------------------    
    # (Step 1/9)
    # -------------------------------------------------------------------------------------          
    
    class2print = "get_preparation_data4xi"
    method2print = "get_preparation_data4xi"    
    

    message2print = "{(Step 1/9a) started" + "; get-preparation-data4xi-started: " + str(get_preparation_data4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
   
    message2print = "{(Step 1/9b) passed" + "; name-passed-to-get-preparation-data4xi: " + str(name) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # Process4Xi-1
     
    # -------------------------------------------------------------------------------------    
    #
    # -------------------------------------------------------------------------------------          
    if examine4xi(class2print, method2print):      
        # ---------------------------------------------------------------------------------    
        # StepOriginal OK
        # ---------------------------------------------------------------------------------             
        message2print = "{(StepOriginal) returning" + "; forking-get-preparation-data-function-returning-by-get-preparation-data4xi: " + str(forking.get_preparation_data) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 

        return forking.get_preparation_data(name)
    else:
            
        # -----------------------------------------------------------------------------------------
        # (Step 2/9)       
        # -----------------------------------------------------------------------------------------           
       
        message2print = "{(Step 2/9a) got" + "; sys-path-got-by-get-preparation-data4xi: " + str(sys.path)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 'sys_path': ['E:\\Sw4Xi\\Python32\\Lib\\multiprocessing4xi', 'd:\\Python32', 'D:\\Windows\\system32\\python32.zip', 'd:\\Python32\\DLLs', 'd:\\Python32\\lib', 'd:\\Python32\\lib\\site-packages'] 
       
        message2print = "{(Step 2/9b) got" + "; sys-argv-got-by-get-preparation-data4xi: " + str(sys.argv)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # ['hello_world4xi.py'] 
 
        message2print = "{(Step 2/9c) got" + "; original-dir4xi-got-by-get-preparation-data4xi: " + str(get_original_dir4xi())  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 'E:\\Sw4Xi\\Python32\\Lib\\multiprocessing4xi'
        
        message2print = "{(Step 2/9d) got" + "; authkey-current-process4xi-got-by-get-preparation-data4xi: " + str(get_authkey_current_process4xi())  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #    b'\x02\xf1\x87\x9a\xa6\x92\xab\xc74\xc2t7s6\xe2\xc7\xb4\xcfl \xfbL\xa3\x95\x88Z\x03\xd4\xf8yy8'
        #HW: b'\xcb\xb9\x96\x8by\xffE\x9a\xa8\x9c\xf0\xcf\xd5\x99\xc6\xba\xf2\x812FQ\xb1[\x84\xf1t\x84\x85\xed\x9c\xd9?'
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/9)           
        # ----------------------------------------------------------------------------------------- 
        dictionary2xi = dict(
            name=name,
            sys_path=sys.path,
            sys_argv=sys.argv,
            log_to_stderr = True,
            orig_dir=get_original_dir4xi(),
            authkey=get_authkey_current_process4xi(),
            )

        message2print = "{(Step 3/9a) got" + "; dictionary2xi-name-got-by-get-preparation-data4xi: " + str(dictionary2xi['name'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # Process4Xi-1
        

        message2print = "{(Step 3/9b) got" + "; dictionary2xi-sys-path-got-by-get-preparation-data4xi: " + str(dictionary2xi['sys_path'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # ['E:\\Sw4Xi\\Python32\\Lib\\multiprocessing4xi', 'd:\\Python32', 'D:\\Windows\\system32\\python32.zip', 'd:\\Python32\\DLLs', 'd:\\Python32\\lib', 'd:\\Python32\\lib\\site-packages'] 
                
        message2print = "{(Step 3/9c) got" + "; dictionary2xi-sys-argv-got-by-get-preparation-data4xi: " + str(dictionary2xi['sys_argv'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #['hello_world4xi.py']

        message2print = "{(Step 3/9d) got" + "; dictionary2xi-log-to-stderr-got-by-get-preparation-data4xi: " + str(dictionary2xi['log_to_stderr'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # True
        
        message2print = "{(Step 3/9e) got" + "; dictionary2xi-orig-dir-got-by-get-preparation-data4xi: " + str(dictionary2xi['orig_dir'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # e:\Sw4Xi\Python32\Lib\multiprocessing4xi
        
        message2print = "{(Step 3/9f) got" + "; dictionary2xi-authkey-got-by-get-preparation-data4xi: " + str(dictionary2xi['authkey'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # b'\x02\xf1\x87\x9a\xa6\x92\xab\xc74\xc2t7s6\xe2\xc7\xb4\xcfl \xfbL\xa3\x95\x88Z\x03\xd4\xf8yy8'
        
        # -----------------------------------------------------------------------------------------
        # (Step 4/9) 
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 4/9) informed" + "; log-level-skipping-informed-by-get-preparation-data4xi: " + "* dictionary2xi log_level key not set *" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # * dictionary2xi log_level key not set *

        # -----------------------------------------------------------------------------------------
        # (Step 5/9)           
        # -----------------------------------------------------------------------------------------          
        cf2xi = ConstantForking4Xi()
        
        message2print = "{(Step 5/9) set" + "; cf2xi-set-by-get-preparation-data4xi to: " + str(cf2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # constant_forking4xi.ConstantForking4Xi object at 0x02AE1310        
        
        if not cf2xi.get_winexe(): #dragonized WINEXE4XI
        
            # ------------------------------------------------------------------------------------
            # (Step 6/9)
            # ------------------------------------------------------------------------------------
          
            main_path2xi = getattr(sys.modules['__main__'], '__file__', None)
            
            message2print = "{(Step 6/9) got" + "; main-path2xi-got-by-get-preparation-data4xi to: " + str(main_path2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # hello_world4xi.py   
        
            # ------------------------------------------------------------------------------------
            # (Step 7/9)
            # ------------------------------------------------------------------------------------
               
            if not main_path2xi and sys.argv[0] not in ('', '-c'):
                main_path2xi = sys.argv[0]    

                message2print = "{(Step 7/9) set" + "; main-path2xi-set-by-get-preparation-data4xi to: " + str(main_path2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #
        
            # ------------------------------------------------------------------------------------
            # (Step 8/9)
            # ------------------------------------------------------------------------------------
   
            if main_path2xi is not None:
                if not os.path.isabs(main_path2xi) and \
                                          get_original_dir4xi() is not None:
                    main_path2xi = os.path.join(get_original_dir4xi(), main_path2xi)

                    message2print = "{(Step 8/9a) set" + "; main_path2xi-set-by-get-preparation-data4xi to: " + str(main_path2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # e:\Sw4Xi\Python32\Lib\multiprocessing4xi\hello_world4xi.py
   

                dictionary2xi['main_path'] = os.path.normpath(main_path2xi)

                message2print = "{(Step 8/9b) set" + "; dictionary2xi-main-path-set-by-get-preparation-data4xi to: " + str(dictionary2xi['main_path'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # e:\Sw4Xi\Python32\Lib\multiprocessing4xi\hello_world4xi.py
                
        # -----------------------------------------------------------------------------------------
        # (Step 9/9)           
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 9/9) returning" + "; dictionary2xi-returning-by-get-preparation-data4xi: " + str(dictionary2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # {     'authkey': 'b\'\\xc3\\xf5\\xb7\\xc5y|\\xf6"\\xf5\\x1f0\\x85P\\x9c\\xa1\\x02\\xf3\\xe2\\x84\\xca\\x12\\x96\\x00O\\xd6\\xc6OF\\x16s\\x838\'',
        #      'sys_path': ['E:\\Sw4Xi\\Python32\\Lib\\multiprocessing4xi', 'd:\\Python32', 'D:\\Windows\\system32\\python32.zip', 'd:\\Python32\\DLLs', 'd:\\Python32\\lib', 'd:\\Python32\\lib\\site-packages'], 
        #          'name': 'Process4Xi-1', 
        #      'orig_dir': 'e:\\Sw4Xi\\Python32\\Lib\\multiprocessing4xi', 
        #      'sys_argv': ['hello_world4xi.py'], 
        #     'main_path': 'e:\\Sw4Xi\\Python32\\Lib\\multiprocessing4xi\\hello_world4xi.py', 
        # 'log_to_stderr': True
        #}
   
        return dictionary2xi

#</function4xi> 
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   hello_world4xi.txt
#   sense-hello-world4xi.xml
#   reason-hello-world4xi.xml
#   ace-hello-world4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of get_preparation_data4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

